require 'mqtt'
require 'json'

class MqttReader
   def get
       puts "MQTT:"
       temperature_topic = 'softwareengineering/thermostat/doni/temperature'
       client = MQTT::Client.new
       client.host = 'mqtt.labict.be'
       client.connect() do |client|
         while true
           client.get(temperature_topic) do |topic,message|
               cJson = message
               cHash = JSON.parse(cJson)
                   cTemp = (cHash["temperature"]).to_f
               @on_change_block.call(cTemp) unless @on_change_block.nil?
           end
        end
       end
   end

   def on_change &block
     @on_change_block = block
   end

   def send(color)
       client2 = MQTT::Client.connect('mqtt.labict.be')
       my_hash = {"color" => color}
       payload = JSON.generate(my_hash)
       client2.publish('softwareengineering/thermostat/doni/led', payload, retain=false)
   end
end
